﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GrapeCity.ActiveReports.Samples.EndUserDesigner
{
    public partial class DataSourceForm : Form
    {
        public DataTable DataSource { get; set; }
        private DataTable _dsTable=new DataTable();
        private Dictionary<string, Type> AllDataTypes = new Dictionary<string, Type>();

        public DataSourceForm()
        {
            InitializeComponent();
            GetAllDataTypes();
            cmbDataType.SelectedIndex = 0;
        }

        void GetAllDataTypes()
        {
            AllDataTypes = new Dictionary<string, Type>();
            AllDataTypes.Add("Int", typeof(int));
            AllDataTypes.Add("String", typeof(string));
            AllDataTypes.Add("DateTime", typeof(DateTime));
            AllDataTypes.Add("Decimal", typeof(decimal));
            AllDataTypes.Add("Bool", typeof(bool));
        }

        private void btnAddField_Click(object sender, EventArgs e)
        {
            if (txtFieldName.Text == "")
            {
                MessageBox.Show("Enter a field name");
                return;
            }
            try
            {
                _dsTable.Columns.Add(txtFieldName.Text, AllDataTypes[cmbDataType.SelectedItem.ToString()]);
                dsGridView.DataSource = _dsTable;
                txtFieldName.Text = "";
                cmbDataType.SelectedIndex = 0;
            }
            catch(DataException ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            _dsTable.AcceptChanges();
            DataSource = _dsTable;
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }
    }
}
